public inbox for linux-btrfs@vger.kernel.org
 help / color / mirror / Atom feed
From: Anand Jain <anand.jain@oracle.com>
To: Johannes Thumshirn <johannes.thumshirn@wdc.com>,
	Zorro Lang <zlang@redhat.com>
Cc: Filipe Manana <fdmanana@suse.com>,
	fstests@vger.kernel.org, linux-btrfs@vger.kernel.org
Subject: Re: [PATCH v6 5/9] btrfs: add fstest for stripe-tree metadata with 4k write
Date: Wed, 27 Dec 2023 20:49:33 +0530	[thread overview]
Message-ID: <37f24bda-fe2c-fd82-38eb-d5d0e3e54842@oracle.com> (raw)
In-Reply-To: <20231213-btrfs-raid-v6-5-913738861069@wdc.com>

On 13/12/2023 17:05, Johannes Thumshirn wrote:
> Test a simple 4k write on all RAID profiles currently supported with the
> raid-stripe-tree.
> 
> Reviewed-by: Filipe Manana <fdmanana@suse.com>
> Signed-off-by: Johannes Thumshirn <johannes.thumshirn@wdc.com>
> ---
>   tests/btrfs/304     | 58 +++++++++++++++++++++++++++++++++++++++++++++++++++++
>   tests/btrfs/304.out | 58 +++++++++++++++++++++++++++++++++++++++++++++++++++++
>   2 files changed, 116 insertions(+)
> 
> diff --git a/tests/btrfs/304 b/tests/btrfs/304
> new file mode 100755
> index 000000000000..05a4ae32639d
> --- /dev/null
> +++ b/tests/btrfs/304
> @@ -0,0 +1,58 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +# Copyright (c) 2023 Western Digital Cooperation.  All Rights Reserved.
> +#
> +# FS QA Test 304
> +#
> +# Test on-disk layout of RAID Stripe Tree Metadata writing 4k to a new file on
> +# a pristine file system.
> +#
> +. ./common/preamble
> +_begin_fstest auto quick raid remount volume raid-stripe-tree
> +
> +. ./common/filter
> +. ./common/filter.btrfs
> +
> +_supported_fs btrfs
> +_require_btrfs_command inspect-internal dump-tree
> +_require_btrfs_mkfs_feature "raid-stripe-tree"
> +_require_scratch_dev_pool 4
> +_require_btrfs_fs_feature "raid_stripe_tree"
> +_require_btrfs_fs_feature "free_space_tree"
> +_require_btrfs_free_space_tree
> +_require_btrfs_no_compress
> +


> +test _get_page_size -eq 4096 || _notrun "this tests requires 4k pagesize"
> +

I made the following changes, to make this test-case run.
Also, in 30[5,6]

-----
diff --git a/tests/btrfs/304 b/tests/btrfs/304
index 05a4ae32639d..f1db52c1ba5c 100755
--- a/tests/btrfs/304
+++ b/tests/btrfs/304
@@ -22,7 +22,7 @@ _require_btrfs_fs_feature "free_space_tree"
  _require_btrfs_free_space_tree
  _require_btrfs_no_compress

-test _get_page_size -eq 4096 || _notrun "this tests requires 4k pagesize"
+test $(_get_page_size) -eq 4096 || _notrun "this tests requires 4k 
pagesize"

  test_4k_write()
  {
-------

Thanks, Anand


> +test_4k_write()
> +{
> +	local profile=$1
> +	local ndevs=$2
> +
> +	_scratch_dev_pool_get $ndevs
> +
> +	echo "==== Testing $profile ===="
> +	_scratch_pool_mkfs -d $profile -m $profile -O raid-stripe-tree
> +	_scratch_mount
> +
> +	$XFS_IO_PROG -fc "pwrite 0 4k" "$SCRATCH_MNT/foo" | _filter_xfs_io
> +
> +	_scratch_cycle_mount
> +	md5sum "$SCRATCH_MNT/foo" | _filter_scratch
> +
> +	_scratch_unmount
> +
> +	$BTRFS_UTIL_PROG inspect-internal dump-tree -t raid_stripe $SCRATCH_DEV_POOL |\
> +		_filter_btrfs_version |  _filter_stripe_tree
> +
> +	_scratch_dev_pool_put
> +}
> +
> +echo "= Test basic 4k write ="
> +test_4k_write raid0 2
> +test_4k_write raid1 2
> +test_4k_write raid10 4
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/btrfs/304.out b/tests/btrfs/304.out
> new file mode 100644
> index 000000000000..48036efbf0cf
> --- /dev/null
> +++ b/tests/btrfs/304.out
> @@ -0,0 +1,58 @@
> +QA output created by 304
> += Test basic 4k write =
> +==== Testing raid0 ====
> +wrote 4096/4096 bytes at offset 0
> +XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
> +5fed275e7617a806f94c173746a2a723  SCRATCH_MNT/foo
> +
> +raid stripe tree key (RAID_STRIPE_TREE ROOT_ITEM 0)
> +leaf XXXXXXXXX items X free space XXXXX generation X owner RAID_STRIPE_TREE
> +leaf XXXXXXXXX flags 0x1(WRITTEN) backref revision 1
> +checksum stored <CHECKSUM>
> +checksum calced <CHECKSUM>
> +fs uuid <UUID>
> +chunk uuid <UUID>
> +	item 0 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 24
> +			encoding: RAID0
> +			stripe 0 devid 1 physical XXXXXXXXX
> +total bytes XXXXXXXX
> +bytes used XXXXXX
> +uuid <UUID>
> +==== Testing raid1 ====
> +wrote 4096/4096 bytes at offset 0
> +XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
> +5fed275e7617a806f94c173746a2a723  SCRATCH_MNT/foo
> +
> +raid stripe tree key (RAID_STRIPE_TREE ROOT_ITEM 0)
> +leaf XXXXXXXXX items X free space XXXXX generation X owner RAID_STRIPE_TREE
> +leaf XXXXXXXXX flags 0x1(WRITTEN) backref revision 1
> +checksum stored <CHECKSUM>
> +checksum calced <CHECKSUM>
> +fs uuid <UUID>
> +chunk uuid <UUID>
> +	item 0 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 40
> +			encoding: RAID1
> +			stripe 0 devid 1 physical XXXXXXXXX
> +			stripe 1 devid 2 physical XXXXXXXXX
> +total bytes XXXXXXXX
> +bytes used XXXXXX
> +uuid <UUID>
> +==== Testing raid10 ====
> +wrote 4096/4096 bytes at offset 0
> +XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
> +5fed275e7617a806f94c173746a2a723  SCRATCH_MNT/foo
> +
> +raid stripe tree key (RAID_STRIPE_TREE ROOT_ITEM 0)
> +leaf XXXXXXXXX items X free space XXXXX generation X owner RAID_STRIPE_TREE
> +leaf XXXXXXXXX flags 0x1(WRITTEN) backref revision 1
> +checksum stored <CHECKSUM>
> +checksum calced <CHECKSUM>
> +fs uuid <UUID>
> +chunk uuid <UUID>
> +	item 0 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 40
> +			encoding: RAID10
> +			stripe 0 devid 1 physical XXXXXXXXX
> +			stripe 1 devid 2 physical XXXXXXXXX
> +total bytes XXXXXXXX
> +bytes used XXXXXX
> +uuid <UUID>
> 


  reply	other threads:[~2023-12-27 15:19 UTC|newest]

Thread overview: 13+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2023-12-13 11:35 [PATCH v6 0/9] fstests: add tests for btrfs' raid-stripe-tree feature Johannes Thumshirn
2023-12-13 11:35 ` [PATCH v6 1/9] fstests: doc: add new raid-stripe-tree group Johannes Thumshirn
2023-12-13 11:35 ` [PATCH v6 2/9] common: add filter for btrfs raid-stripe dump Johannes Thumshirn
2023-12-13 11:35 ` [PATCH v6 3/9] common: add _require_btrfs_no_nodatacow helper Johannes Thumshirn
2023-12-13 11:35 ` [PATCH v6 4/9] common: add _require_btrfs_free_space_tree Johannes Thumshirn
2023-12-13 11:35 ` [PATCH v6 5/9] btrfs: add fstest for stripe-tree metadata with 4k write Johannes Thumshirn
2023-12-27 15:19   ` Anand Jain [this message]
2023-12-29 12:08     ` Anand Jain
2024-01-08 12:38       ` Johannes Thumshirn
2023-12-13 11:35 ` [PATCH v6 6/9] btrfs: add fstest for 8k write spanning two stripes on raid-stripe-tree Johannes Thumshirn
2023-12-13 11:35 ` [PATCH v6 7/9] btrfs: add fstest for writing to a file at an offset with RST Johannes Thumshirn
2023-12-13 11:35 ` [PATCH v6 8/9] btrfs: add fstests to write 128k to a RST filesystem Johannes Thumshirn
2023-12-13 11:35 ` [PATCH v6 9/9] btrfs: add fstest for overwriting a file partially with RST Johannes Thumshirn

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=37f24bda-fe2c-fd82-38eb-d5d0e3e54842@oracle.com \
    --to=anand.jain@oracle.com \
    --cc=fdmanana@suse.com \
    --cc=fstests@vger.kernel.org \
    --cc=johannes.thumshirn@wdc.com \
    --cc=linux-btrfs@vger.kernel.org \
    --cc=zlang@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox